//--------------------------------------//
//	[CPartsTest5.cpp]					//
//	C-PartsgShadevOC		//
//	t[eBOEBhẼeXg	//
//	2002.04.13 - 2002.09.28				//
//		Yutaka Yoshisaka				//
//--------------------------------------//

struct allocator_class { };

#include <vector>

#include <stdio.h>
#include <stdlib.h>

//C-PartsŎgpwb_
#include "CPartsMain.h"

#include "CPWindow.h"
#include "CPLabel.h"
#include "CPEditBox.h"
#include "CPPushButton.h"
#include "CPGroup.h"
#include "CPProgressBar.h"
#include "CPCheckBox.h"
#include "CPRadioButton.h"
#include "CPSlider.h"
#include "CPTab.h"
#include "CPComboBox.h"
#include "CPSpin.h"
#include "CPSpinEditBox.h"
#include "CPImage.h"
#include "CPButton.h"
#include "CPColor.h"
#include "CPFileCtrl.h"
#include "CPListBox.h"

#include "CPString.h"


#include "CPartsSI.h"	//C-Parts - Shade ̃ubW

#if !INLINED_PLUGIN
#include "com.cpp"
#include "vectors.cpp"
#endif
#if WIN32
	#include "windows.h"
#endif
#include "shadetypes.h"
#include "sceneinterface.h"
#include "imageinterface.h"
#include "renderinginterface.h"
#include "renderingcontextinterface.h"
#include "correctioninterface.h"
#include "shapeclass.h"
#include "progressdialoginterface.h"
#include "sceneinterface.h"
#include "shadeinterface.h"
#include "pluginids.h"
#include "dllentries.h"
#include "camerainterface.h"
#include "shapeinterface.h"


struct plugin_component;
static plugin_component *lpThis=NULL;

//vOCID́A
//SDN胆[U[̌ŗLID炤悤ɂĂ
const int cparts_plugin_id = 0x434ff010;

struct plugin_component : plugin_interface {
	plugin_component (shade_interface *shade) {
		m_shade=shade;
		lpThis=this;
	}

	~plugin_component () {
		//C-Parts̏I
		CPartsSI_Terminate();
	}
	virtual int get_shade_version () const { return SHADE_VERSION; }

	virtual void do_it (shade_interface *shade, scene_interface *scene, void *);
	virtual int get_id (void * = 0) { return cparts_plugin_id; }

	virtual void scene_opened (sxbool &b, scene_interface *scene, void * = 0) {
		//C-Parts
		CPartsSI_Initialize(scene);
	}

	//----------------------------------------------//
	//	ubZ[Wv{^ꂽ				//
	//----------------------------------------------//
	static void OnMessageBut(CPPushButton *lpBut)
	{
		if(lpThis && lpThis->m_shade){
			if(lpThis->m_shade->is_japanese_mode()){
				char szStr[256];
				CPString conv;
				
				//Shift-JISUTF-8ɕϊ
				conv.ConvSJIS_UTF8("bZ[W̕\",szStr,255);
				
				lpThis->m_shade->message(szStr);
				
			} else {
				lpThis->m_shade->message("message ok!!");
				
			}
		}
	}

	//----------------------------------------------//
	//	uv{^ꂽ					//
	//----------------------------------------------//
	static void OnCloseBut(CPPushButton *lpBut)
	{
		//{^ꂽƂɁAEBhE
		lpBut->GetParentWindow()->CloseWindow();
	}

public:
	shade_interface *m_shade;

private:

	//R[obN֐łgpIuWFNg
	CPWindow cp_win;			//C-PartspEBhEǗNX
	CPPushButton cp_CloseBut;	//uv{^
	CPPushButton cp_MesBut;		//ubZ[Wv{^

};

void plugin_component::do_it(shade_interface *shade, scene_interface *scene, void *) {

	if (scene) {
		//--------------------------------------//
		//	[hX̃EBhE̐	//
		//--------------------------------------//
		cp_win.Clear();
		if(cp_win.CreateNewWindow("C-Parts Test Window",120,120,132,70,CP_WINDOW_TOOLWINDOW)<0){
			shade->message("CreateNewWindow failed!!");
			return;
		}

		//--------------------------//
		//	_CAO̕iݒ	//
		//--------------------------//

		//ubZ[Wv{^̔zu
		cp_MesBut.SetBounds(8,8,120,20);
		cp_MesBut.SetText("bZ[W");
		cp_MesBut.AttachSelectEvent(this->OnMessageBut);
		cp_MesBut.SetHintText("bZ[W\܂B");
		cp_win.Add(&cp_MesBut);

		//uv{^̔zu
		cp_CloseBut.SetText("");
		cp_CloseBut.SetBounds(8,36,120,20);
		cp_CloseBut.AttachSelectEvent(this->OnCloseBut);
		cp_CloseBut.SetHintText("EBhE܂B");
		cp_win.Add(&cp_CloseBut);

		//EBhE̕\
		cp_win.ShowWindow(CP_TRUE);
	}

}


#if __MWERKS__
	#pragma export on
#endif

extern_c void STDCALL create_interface(const IID &iid, int i, void **p, shade_interface *shade, void *) {
	unknown_interface *u = 0;

	u = new plugin_component(shade);

	u->AddRef();
	*p = (void *)u;
};

extern_c int STDCALL has_interface(const IID &iid, shade_interface *shade) {

	if (iid == plugin_iid) return 1;
	return 0;
}

extern_c const char * STDCALL get_name(const IID &iid, int i, shade_interface *shade, void *) {
	return "CParts-Sample5";
}

extern_c int STDCALL get_interface_version(void *) {
	return interface_version;
}

extern_c int STDCALL get_id(const IID &iid, int i, void *) {
	return cparts_plugin_id;
}

extern_c bool STDCALL is_resident(const IID &iid, int i, void *) {
	//K풓
	return true;
}

extern_c int STDCALL get_text_encoding(shade_interface *shade, void *) {
	return shade->is_japanese_mode() ? plugin_interface::japanese_encoding : 0;
}

//----------------------------------------------//
//	C^[tF[X̎w					//
//----------------------------------------------//
extern_c void STDCALL get_info (shade_plugin_info &info, shade_interface *shade, void *) {

	info.sdk_version = SDK_VERSION;
	//info.recommended_shade_version = 35000;
	info.major_version = 1;
	info.minor_version = 0;
	info.micro_version = 0;
	info.build_number = 1;
	info.product_name = "CParts-Sample5";
	info.author = "Y.Yutaka";
	info.company = "";
	info.comments = "C-Parts̃eXgvOCłB\nt[eBOEBhE\܂B";
}

