//////////////////////////////////////
//	[CPEditBox.h]					//
//	̓tB[h`EǗNX	//
//	from 2001.02.04					//
//	to   2002.07.19					//
//	Writer : Yoshisaka Yutaka		//
//////////////////////////////////////

#ifndef _CPEDITBOX_H
#define _CPEDITBOX_H

#include "CPartsMain.h"
#include "CPGraphics.h"

class CPWindow;
class CPEditBox;
typedef void (* LP_EDITBOXPROC)(CPEditBox *);

//----- GfBbg{bNX̃[h -----
#define CP_EDIT_NORMAL		0		//ʂ̓
#define CP_EDIT_NUMBERONLY	1		//l݂̂̓
#define CP_EDIT_ASCIIONLY	2		//ASCIÎ݂̓

class LibExport CPEditBox : public CPGraphics
{
private:
	//̕sȂ߂̋lߕ
	CP_SHLIB_DUMMY1024

public:
	CP_SHLIB_DUMMY128

	//----------------------------------------------//
	//	ʂɌJ郁\bh̐錾				//
	//----------------------------------------------//
	CPEditBox();
	~CPEditBox();

	//----- ݒs -----
	void SetBounds(int x,int y,int wid,int hei);	//\ʒuƃTCYw
	void SetSize(int wid,int hei);					//\TCYw
	void SetLocate(int x,int y);					//\ʒuw
	void SetVisible(CP_BOOL f);						//\邩Ȃ

	void SetEnable(CP_BOOL f);							//ɂ邩ǂ
	void SetText(char *lpStr);						//\镶w
	void SetBackgroundColor(unsigned long col);		//wiFw
	void SetForegroundColor(unsigned long col);		//OiFw
	void SetSelectBackgroundColor(unsigned long col);	//I̔wiFw
	void SetSelectForegroundColor(unsigned long col);	//ȊOiFw
	void SetCursorColor(unsigned long col);			//J[\F̎w
	
	void SetMaxLength(int len);						//͂łőTCY̎w
	void SetEditMode(int opt);						//̓[hw

	//----- J[\̏ ----
	CP_BOOL CursorSelect(int start,int end);			//J[\ɂ͈͑I
	void CursorSelectAll();							//J[\ɂSI
	CP_BOOL CursorPosition(int x);						//J[\ʒuړ

	void Clear();									//ׂĉ

	//----- 擾s -----
	void GetText(char *lpStr,int StrLen);			//\镶擾
	void GetBounds(CPSTRect *lpRec);				//\ʒuETCY擾
	void GetSize(CPSTSize *lpSize);					//\TCY擾
	void GetLocate(CPSTPosition *lpPos);			//\ʒu擾
	CP_BOOL IsVisible();							//\邩Ȃ

	CP_BOOL IsEnable();								//LEɂ邩ǂ
	unsigned long GetBackgroundColor();				//wiF擾
	unsigned long GetForegroundColor();				//OiF擾
	unsigned long GetSelectBackgroundColor();		//I̔wiF擾
	unsigned long GetSelectForegroundColor();		//ȊOiF擾
	unsigned long GetCursorColor();					//J[\F̎擾

	int GetMaxLength();								//͂łőTCY̎擾
	int GetEditMode();								//̓[h擾

	CP_BOOL GetCursorSelect(int *lpStart,int *lpEnd);	//J[\ł̑I͈͂̎擾
	int GetCursorPosition();							//J[\ʒu̎擾

	//----- Cxg̑Ή -----
	CP_BOOL AttachFocusEvent(LP_EDITBOXPROC lpProc);		//GfBbg{bNXɃtH[JXꍇ̃Cxg󂯎
	void DetachFocusEvent();								//Cxg̉
	CP_BOOL AttachChangeEvent(LP_EDITBOXPROC lpProc);		//GfBbg{bNX̕񂪕ύXꂽꍇ̃Cxg󂯎
	void DetachChangeEvent();								//Cxg̉

	CPWindow *GetParentWindow();	//ẽEBhENX擾
	void Repaint();					//Rg[̍ĕ`s

	//----- c[qg̐p -----
	void SetHintText(char *lpStr);					//c[qg̕wis\j
	void SetHintFontSize(int fSize);				//c[qg̃tHgTCYw
	void SetHintForegroundColor(unsigned long col);	//c[qg̕Fw
	void SetHintBackgroundColor(unsigned long col);	//c[qg̔wiFw

};

#endif
