//////////////////////////////////////
//	[CPProgressBar.h]				//
//	vOXo[`EǗNX	//
//	from 2001.02.10					//
//	to   2002.07.19					//
//	Writer : Yoshisaka Yutaka		//
//////////////////////////////////////

#ifndef _CPPROGRESSBAR_H
#define _CPPROGRESSBAR_H

#include "CPartsMain.h"
#include "CPGraphics.h"

//vOXo[̃X^C
#define CP_PROGRESSBAR_NORMAL		0
#define CP_PROGRESSBAR_GRADATION	1

class CPWindow;

class LibExport CPProgressBar : public CPGraphics
{
private:
	//̕sȂ߂̋lߕ
	CP_SHLIB_DUMMY256

public:
	CP_SHLIB_DUMMY128

	//----------------------------------------------//
	//	ʂɌJ郁\bh̐錾				//
	//----------------------------------------------//
	CPProgressBar();
	CPProgressBar(int m);
	~CPProgressBar();

	//----- ݒs -----
	void SetBounds(int x,int y,int wid,int hei);	//\ʒuƃTCYw
	void SetSize(int wid,int hei);					//\TCYw
	void SetLocate(int x,int y);					//\ʒuw
	void SetVisible(CP_BOOL f);						//\邩Ȃ

	void SetBackgroundColor(unsigned long col);		//wiFw
	void SetForegroundColor(unsigned long col);		//OiFw
	CP_BOOL SetRange(int min,int max);					//vOXo[̍ŏEőlݒ
	void SetPosition(int p);						//vOXo[݂̌̈ʒuݒ
	void SetMode(int m);							//vOXo[̃[h

	void Clear();					//ׂĉ

	//----- 擾s -----
	void GetBounds(CPSTRect *lpRec);				//\ʒuETCY擾
	void GetSize(CPSTSize *lpSize);					//\TCY擾
	void GetLocate(CPSTPosition *lpPos);			//\ʒu擾
	CP_BOOL IsVisible();							//\邩Ȃ

	unsigned long GetBackgroundColor();				//wiF擾
	unsigned long GetForegroundColor();				//OiF擾
	CP_BOOL GetRange(int *lpMin,int *lpMax);					//vOXo[͈̔͂擾
	int GetPosition();								//vOXo[̈ʒu擾
	int GetMode();									//vOXo[̃[h擾

	CPWindow *GetParentWindow();	//ẽEBhENX擾
	void Repaint();					//Rg[̍ĕ`s

	//----- c[qg̐p -----
	void SetHintText(char *lpStr);					//c[qg̕wis\j
	void SetHintFontSize(int fSize);				//c[qg̃tHgTCYw
	void SetHintForegroundColor(unsigned long col);	//c[qg̕Fw
	void SetHintBackgroundColor(unsigned long col);	//c[qg̔wiFw

};
#endif
