//////////////////////////////////////
//	[CPScrollArea.h]				//
//	XN[̈ǗNX		//
//	C-Parts Ver1.10Œǉ			//
//	from 2002.07.24					//
//	to   2002.07.26					//
//	Writer : Yoshisaka Yutaka		//
//////////////////////////////////////

#ifndef _CPSCROLLAREA_H
#define _CPSCROLLAREA_H

#include "CPartsMain.h"
#include "CPGraphics.h"

#include "CPLabel.h"
#include "CPPushButton.h"
#include "CPEditBox.h"
#include "CPProgressBar.h"
#include "CPCheckBox.h"
#include "CPRadioButton.h"
#include "CPSlider.h"
#include "CPTab.h"
#include "CPComboBox.h"
#include "CPSpin.h"
#include "CPSpinEditBox.h"
#include "CPImage.h"
#include "CPColor.h"
#include "CPButton.h"
#include "CPListBox.h"

#define CP_SCROLL_NOSCROLLBAR	0		//XN[o[B
#define CP_SCROLL_HSCROLLBAR	0x01	//XN[o[\
#define CP_SCROLL_VSCROLLBAR	0x02	//XN[o[\


class CPScrollArea : public CPGraphics
{
private:
	//̕sȂ߂̋lߕ
	CP_SHLIB_DUMMY512

public:
	CP_SHLIB_DUMMY128

	//----------------------------------------------//
	//	ʂɌJ郁\bh̐錾				//
	//----------------------------------------------//
	CPScrollArea();
	~CPScrollArea();

	void SetBounds(int x,int y,int wid,int hei);	//\ʒuƃTCYw
	void SetSize(int wid,int hei);					//\TCYw
	void SetLocate(int x,int y);					//\ʒuw
	void SetVisible(CP_BOOL f);						//\邩Ȃ
	void SetScrollSize(int wid,int hei);			//XN[̈̃TCYw

	void SetMode(int m);							//XN[o[̕\[h
	void SetBackMode(int mode);						//wi𓧖ɂ邩w
	void SetBackgroundColor(unsigned long col);		//wiFw

	void Clear();				//ׂĉ

	//------------------------------------------//
	//	GUIRg[XN[GAɒǉ	//
	//------------------------------------------//
	void Add(CPLabel *lpLabel);
	void Add(CPPushButton *lpPushButton);
	void Add(CPEditBox *lpEditBox);
	void Add(CPGroup *lpGroup);
	void Add(CPProgressBar *lpProgressBar);
	void Add(CPCheckBox *lpCheckBox);
	void Add(CPSlider *lpSlider);
	void Add(CPTab *lpTab);
	void Add(CPComboBox *lpComboBox);
	void Add(CPSpin *lpSpin);
	void Add(CPSpinEditBox *lpSpinEditBox);
	void Add(CPImage *lpImage);
	void Add(CPColor *lpColor);
	void Add(CPButton *lpButton);
	void Add(CPListBox *lpListBox);

	//----------------------------------------------//
	//	GUIRg[XN[GA폜	//
	//----------------------------------------------//
	void RemoveAt(CPLabel *lpLabel);
	void RemoveAt(CPPushButton *lpPushButton);
	void RemoveAt(CPEditBox *lpEditBox);
	void RemoveAt(CPGroup *lpGroup);
	void RemoveAt(CPProgressBar *lpProgressBar);
	void RemoveAt(CPCheckBox *lpCheckBox);
	void RemoveAt(CPSlider *lpSlider);
	void RemoveAt(CPTab *lpTab);
	void RemoveAt(CPComboBox *lpComboBox);
	void RemoveAt(CPSpin *lpSpin);
	void RemoveAt(CPSpinEditBox *lpSpinEditBox);
	void RemoveAt(CPImage *lpImage);
	void RemoveAt(CPColor *lpColor);
	void RemoveAt(CPButton *lpButton);
	void RemoveAt(CPListBox *lpListBox);

	void GetBounds(CPSTRect *lpRec);				//\ʒuETCY擾
	void GetSize(CPSTSize *lpSize);					//\TCY擾
	void GetScrollSize(CPSTSize *lpSize);			//XN[̈̃TCY擾
	void GetLocate(CPSTPosition *lpPos);			//\ʒu擾
	CP_BOOL IsVisible();							//\邩Ȃ

	int GetMode();									//O[ṽ[h̎擾
	int GetBackMode();								//wi𓧖ɂ邩ǂ̃[h擾
	unsigned long GetBackgroundColor();				//wiF擾

	CPWindow *GetParentWindow();	//ẽEBhENX擾
	void Repaint();					//Rg[̍ĕ`s
};

#endif

