//--------------------------------------//
//	[CPartsTest3.cpp]					//
//	C-PartsgShadevOC		//
//	낢GUIi̔zu				//
//	2002.04.12 - 2002.08.28				//
//	Yutaka Yoshisaka					//
//--------------------------------------//
struct allocator_class { };

#include <vector>

#include <stdio.h>
#include <stdlib.h>

//C-PartsŎgpwb_
#include "CPartsMain.h"
#include "CPWindow.h"
#include "CPLabel.h"
#include "CPEditBox.h"
#include "CPPushButton.h"
#include "CPGroup.h"
#include "CPProgressBar.h"
#include "CPCheckBox.h"
#include "CPRadioButton.h"
#include "CPSlider.h"
#include "CPTab.h"
#include "CPComboBox.h"
#include "CPSpin.h"
#include "CPSpinEditBox.h"
#include "CPImage.h"
#include "CPButton.h"
#include "CPColor.h"
#include "CPFileCtrl.h"
#include "CPListBox.h"

#include "CPartsSI.h"	//C-Parts - Shade ̃ubW

#if !INLINED_PLUGIN
#include "com.cpp"
#include "vectors.cpp"
#endif
#if WIN32
	#include "windows.h"
#endif
#include "shadetypes.h"
#include "sceneinterface.h"
#include "imageinterface.h"
#include "renderinginterface.h"
#include "renderingcontextinterface.h"
#include "correctioninterface.h"
#include "shapeclass.h"
#include "progressdialoginterface.h"
#include "sceneinterface.h"
#include "shadeinterface.h"
#include "pluginids.h"
#include "dllentries.h"
#include "camerainterface.h"
#include "shapeinterface.h"


struct plugin_component;
static plugin_component *lpThis=NULL;
static shade_interface *g_shade=NULL;

//vOCID́A
//SDN胆[U[̌ŗLID炤悤ɂĂ
const int cparts_plugin_id = 0x434ff003;

struct plugin_component : plugin_interface {
	plugin_component () {
		g_shade=NULL;
		lpThis=this;
	}

	~plugin_component () {
		//C-Parts̏I
		CPartsSI_Terminate();
	}
	virtual int get_shade_version () const { return SHADE_VERSION; }

	virtual void do_it (shade_interface *shade, scene_interface *scene, void *);
	virtual int get_id (void * = 0) { return cparts_plugin_id; }

	virtual void scene_opened (sxbool &b, scene_interface *scene, void * = 0) {
		//C-Parts
		CPartsSI_Initialize(scene);
	}

	//J擾Eݒ肷
	void SetCameraInfo();

	//_~[̃^u쐬
	void InitDummyTAB();

	//----------------------------------------------//
	//	C-Parts̃Cxg󂯎R[obN֐	//
	//----------------------------------------------//
	static void OnPaint(CPWindow *lpWin,CPSTWindowEvent e)
	{
		/*
		if(e.EventCode==CP_WINDOWEVENT_PAINT){
			lpWin->SetForegroundColor(CP_RGB(255,0,0));
			lpWin->DrawLine(0,0,200,200);
		}
		*/
	}

	//----------------------------------------------//
	//	EBhÉuvꂽ			//
	//----------------------------------------------//
	static void OnClose(CPPushButton *lpBut)
	{
		lpBut->GetParentWindow()->CloseWindow();	//EBhE
	}

	//----------------------------------------------//
	//	WI{^Iꂽ					//
	//----------------------------------------------//
	static void OnRadioButtonSelect(CPGroup *lpGroup)
	{
		//IĂ郉WI{^̔ԍ擾
		int r_pos=lpGroup->GetRadioButton();
		int mode=0;

		switch(r_pos){
			case 0:		//RGBlcp_imageɔf
				mode=0;
				break;
			case 1:		//Alcp_imageɔf
				mode=1;
				break;

			case 2:		//Zlcp_imageɔf
				mode=2;
		}

		//C-PartsCPImageShadẽ_O摜n
		if(g_shade){
			compointer<scene_interface> sc(g_shade->get_scene_interface());
			if(sc){
				CPartsSI_CopyImage(sc,&(lpThis->cp_image),CP_RGB(32,32,48),mode);
				lpThis->cp_image.Repaint();	//摜̍ĕ`
			}
		}
	}

	//----------------------------------------------//
	//	Xg{bNXIꂽ					//
	//----------------------------------------------//
	static void OnListBoxSelect(CPListBox *lpListBox)
	{
		char szBuff[256];
		int Index;

		//Xg{bNXőIĂs擾
		Index=lpListBox->GetListIndex();

		sprintf(szBuff,"choice=%d",Index);
		lpThis->cp_ListCLab.SetText(szBuff);
		lpThis->cp_ListCLab.Repaint();	//x̍ĕ`
	}

public:
	//R[obN֐łgpIuWFNg
	CPWindow cp_win;		//C-PartspEBhEǗNX
	CPImage cp_image;

private:

	//C-PartsŗpRg[
	CPPushButton cp_butClose;
	CPLabel cp_lab1,cp_lab2;
	CPLabel cp_cameraPosLab1,cp_cameraPosLab2;
	CPLabel cp_cameraTarLab1,cp_cameraTarLab2;

	CPGroup cp_group;
	CPRadioButton cp_rbRGB,cp_rbZ,cp_rbA;
	CPTab cp_Tab;
	CPGroup cp_TabG1,cp_TabG2,cp_TabG3;

	CPListBox cp_ListBox;
	CPLabel cp_ListCLab;

	//C-Parts̃_~[^ũRg[
	CPLabel cp_dLab,cp_dLab2,cp_dLab3,cp_dLab4;
	CPPushButton cp_dPBut;
	CPCheckBox cp_dChk;
	CPEditBox cp_dEBox;
	CPComboBox cp_dCombo;
	CPGroup cp_dGroup;
	CPProgressBar cp_dProgress;
	CPSlider cp_dSlider;
	CPSpinEditBox cp_dSpin;
	CPImage cp_dImage,cp_TitleImage;
	CPColor cp_dColor;
	CPButton cp_dBut;
};

void plugin_component::do_it(shade_interface *shade, scene_interface *scene, void *) {

	if (scene) {
		compointer<shape_interface> shape(scene->get_active_shape_interface());
        
		//shade_interfacẽ|C^ێ
		g_shade=shade;
		
		//--------------------------//
		//	_CAO̐	//
		//--------------------------//
		cp_win.Clear();
		if(cp_win.CreateNewDialog("ZlElo",120,120,600,480)<0){
			shade->message("CreateNewDialog failed!!");
			return;
		}
		//EBhECxg̎󂯎֐ݒiJX^`sj
		cp_win.AttachWindowEvent(this->OnPaint);

		//--------------------------//
		//	_CAO̕iݒ	//
		//--------------------------//
		cp_lab1.SetText("摜ZlElo܂B");
		cp_lab1.SetBounds(16,8,200,20);
		cp_lab1.SetAlign(CP_ALIGN_LEFT);
		cp_lab1.SetBackMode(CP_TRANSPARENT);

		cp_win.Add(&cp_lab1);

		cp_lab2.SetBounds(16,40,200,20);
		cp_lab2.SetAlign(CP_ALIGN_LEFT);
		cp_lab2.SetBackMode(CP_TRANSPARENT);
		cp_win.Add(&cp_lab2);

		//WI{^̂O[v̍쐬
		cp_group.SetText("o^Cv");
		cp_group.SetBounds(16,320,200,100);
		cp_win.Add(&cp_group);

		cp_rbRGB.SetText("RGBi摜j");
		cp_rbRGB.SetBounds(12,22,140,20);
		cp_rbRGB.SetHintText("摜̃C[Wo܂B");
		cp_group.Add(&cp_rbRGB);
		cp_rbA.SetText("l");
		cp_rbA.SetBounds(12,44,140,20);
		cp_rbA.SetHintText("l̉摜o܂B");
		cp_group.Add(&cp_rbA);
		cp_rbZ.SetText("Zl");
		cp_rbZ.SetBounds(12,66,140,20);
		cp_rbZ.SetHintText("Zobt@l̉摜o܂B");
		cp_group.Add(&cp_rbZ);

		//O[ṽWI{^IɃR[obN֐т
		cp_group.AttachRadioButtonSelectEvent(OnRadioButtonSelect);

		//Xg{bNX̔zu
		cp_ListBox.SetBounds(228,330,112,72);
		cp_ListBox.AddText("Item 0");
		cp_ListBox.AddText("Item 1");
		cp_ListBox.AddText("Item 2");
		cp_ListBox.AddText("Item 3");
		cp_ListBox.AddText("Item 4");
		cp_ListBox.AddText("Item 5");
		cp_ListBox.AddText("Item 6");
		cp_ListBox.AddText("Item 7");
		cp_ListBox.AddText("Item 8");
		cp_ListBox.AddText("Item 9");
		cp_ListBox.AddText("Item 10");
		cp_ListBox.AddText("Item 11");
		cp_ListBox.AddText("Item 12");
		cp_ListBox.AttachSelectEvent(&OnListBoxSelect);
		cp_win.Add(&cp_ListBox);

		cp_ListCLab.SetBounds(228,406,112,20);
		cp_ListCLab.SetBackMode(CP_TRANSPARENT);
		cp_ListCLab.SetText("---");
		cp_win.Add(&cp_ListCLab);

		//^u̐
		cp_Tab.SetBounds(352,64,230,356);
		cp_win.Add(&cp_Tab);

		cp_TabG1.SetBounds(0,0,210,320);
		cp_cameraPosLab1.SetBounds(8,8,200,20);
		cp_cameraPosLab1.SetText("J̈ʒuF");
		cp_cameraPosLab1.SetBackMode(CP_TRANSPARENT);
		cp_cameraPosLab1.SetFontSize(10);
		cp_cameraPosLab2.SetBounds(16,28,200,20);
		cp_cameraPosLab2.SetBackMode(CP_TRANSPARENT);
		cp_cameraPosLab2.SetFontSize(10);
		cp_TabG1.Add(&cp_cameraPosLab1);
		cp_TabG1.Add(&cp_cameraPosLab2);
		cp_cameraTarLab1.SetBounds(8,50,200,20);
		cp_cameraTarLab1.SetText("J̒_F");
		cp_cameraTarLab1.SetBackMode(CP_TRANSPARENT);
		cp_cameraTarLab1.SetFontSize(10);
		cp_cameraTarLab2.SetBounds(16,70,200,20);
		cp_cameraTarLab2.SetBackMode(CP_TRANSPARENT);
		cp_cameraTarLab2.SetFontSize(10);
		cp_TabG1.Add(&cp_cameraTarLab1);
		cp_TabG1.Add(&cp_cameraTarLab2);

		SetCameraInfo();	//J̏Rg[ɓn

		cp_Tab.Add("",&cp_TabG1);
		cp_TabG2.SetBounds(0,0,210,320);
		cp_TabG3.SetBounds(0,0,210,320);
		cp_Tab.Add("Dummy",&cp_TabG2);
		cp_Tab.Add("Dummy(image)",&cp_TabG3);
		InitDummyTAB();		//_~[̃^uɔzu

		//摜̈̐
		cp_image.SetBounds(16,64,320,240);
		cp_win.Add(&cp_image);
		compointer<scene_interface> sc(shade->get_scene_interface());

		//_O摜̃TCY\
		compointer<rendering_interface> render(scene->get_rendering_interface());
		if(render){
			char szBuff[256];
			point_class po=render->get_image_size();

			sprintf(szBuff,"摜TCYF%d x %d",(int)po.h,(int)po.v);
			cp_lab2.SetText(szBuff);
		}		

		//uv{^̔zu
		cp_butClose.SetText("");
		cp_butClose.SetBounds(460,440,120,24);
		cp_butClose.AttachSelectEvent(this->OnClose);
		cp_butClose.SetHintText("_CAO܂B");
		cp_win.Add(&cp_butClose);

		//Eɉ摜\̈zu
		//i摜uplugins/CPartsTest.bmpvǂݍށj
		char szFullPath[256];
		cp_TitleImage.SetBounds(460,12,120,30);
		
		//Shade̎st@CN_Ƃꍇ́A΃pX擾(Mac̏ꍇ͂̂܂)
		CPartsSI_GetFullPath("plugins/CPartsTest.bmp",szFullPath,255);

		//摜̓ǂݍ
		//LoadImage(t@CtpX,摜JnX,摜JnY,]TCY,]TCY,]̊JnX,]̊JnY)
		cp_TitleImage.LoadImage(szFullPath,0,0,120,30,0,0);

		cp_win.Add(&cp_TitleImage);


		//O[ṽWI{^0ԖڂI
		cp_group.SelectRadioButton(0);

		//EBhEi_CAOj\
		//ȉƕ\ɂĂ܂
		//cp_win.ShowWindow(CP_TRUE);

		//[__CAÕCxg
		cp_win.DoModal();

	}
}

//--------------------------------------//
//	J擾Eݒ肷			//
//--------------------------------------//
void plugin_component::SetCameraInfo()
{
	char szBuff[256];
	vec3 pos;

	if(!g_shade) return;

	compointer<scene_interface> scene(g_shade->get_scene_interface());
	if(!scene) return;
	compointer<camera_interface> camera(scene->get_camera_interface());
	if(!camera) return;

	//_W̎擾
	pos=camera->get_eye(0);
	sprintf(szBuff,"( %.3f,%.3f,%.3f )",pos.x,pos.y,pos.z);
	cp_cameraPosLab2.SetText(szBuff);

	//_̒_̎擾
	pos=camera->get_target(0);
	sprintf(szBuff," ( %.3f,%.3f,%.3f )",pos.x,pos.y,pos.z);
	cp_cameraTarLab2.SetText(szBuff);

}

//--------------------------------------//
//	_~[̃^u쐬				//
//--------------------------------------//
void plugin_component::InitDummyTAB()
{
	//x - CPLabel
	cp_dLab.SetBackgroundColor(CP_RGB(64,64,255));
	cp_dLab.SetForegroundColor(CP_RGB(255,255,255));
	cp_dLab.SetBounds(8,8,200,20);
	cp_dLab.SetAlign(CP_ALIGN_CENTER);
	cp_dLab.SetText("_~[̃Rg[");
	cp_TabG2.Add(&cp_dLab);

	//vbV{^ - CPPushButton
	cp_dPBut.SetText("PushButton");
	cp_dPBut.SetBounds(16,32,100,24);
	cp_TabG2.Add(&cp_dPBut);

	//{^ - CPButton
	cp_dBut.SetText("Button");
	cp_dBut.SetBounds(120,32,80,24);
	cp_TabG2.Add(&cp_dBut);

	//`FbN{bNX - CPCheckBox
	cp_dChk.SetBounds(16,64,140,20);
	cp_dChk.SetText("`FbN{bNX");
	cp_TabG2.Add(&cp_dChk);

	//J[ - CPColor
	cp_dColor.SetBounds(170,64,20,20);
	cp_dColor.SetColor(CP_RGB(255,0,0));
	cp_TabG2.Add(&cp_dColor);

	//GfBbg{bNX - CPEditBox
	cp_dEBox.SetText("EditBox");
	cp_dEBox.SetBounds(16,88,140,20);
	cp_dEBox.SetMaxLength(16);
	cp_TabG2.Add(&cp_dEBox);

	//R{{bNX - CPComboBox
	cp_dCombo.SetBounds(16,112,140,20);
	cp_dCombo.AddText("Item1");
	cp_dCombo.AddText("Item2");
	cp_dCombo.AddText("Item3");
	cp_dCombo.AddText("Item4");
	cp_dCombo.AddText("Item5");
	cp_TabG2.Add(&cp_dCombo);

	//O[v - CPGroup
	cp_dGroup.SetBounds(16,140,190,160);
	cp_dGroup.SetText("O[v");
	cp_TabG2.Add(&cp_dGroup);

	//vOXo[iin O[vj - CPProgressBar
	cp_dProgress.SetBounds(16,24,160,12);
	cp_dProgress.SetMode(CP_PROGRESSBAR_GRADATION);
	cp_dProgress.SetForegroundColor(CP_RGB(40,120,255));
	cp_dProgress.SetBackgroundColor(CP_RGB(64,64,110));
	cp_dProgress.SetPosition(74);
	cp_dGroup.Add(&cp_dProgress);

	//XC_[(in O[v) - CPClider
	cp_dSlider.SetBounds(16,48,160,60);
	cp_dSlider.SetRuler(CP_TRUE);
	cp_dGroup.Add(&cp_dSlider);

	//Xs{bNX(in O[v) - CPSpinEditBox
	cp_dSpin.SetBounds(16,120,160,20);
	cp_dSpin.SetValue(10);
	cp_dGroup.Add(&cp_dSpin);

	//摜 - CPImage
	int x,y;
	int rr,gg,bb;
	cp_dImage.SetBounds(20,20,160,200);
	cp_dImage.ClearImage(CP_RGB(20,64,20));

	rr=40;
	gg=40;
	bb=40;
	for(y=0;y<180;y++){
		rr++;
		gg=40;
		for(x=0;x<160;x++){
			gg++;
			cp_dImage.SetForegroundColor(CP_RGB(rr,gg,bb));
			cp_dImage.SetPixel(x,y);
		}
	}
	cp_dImage.SetForegroundColor(CP_RGB(128,0,0));
	cp_dImage.DrawLine(40,40,220,140);
	cp_dImage.SetForegroundColor(CP_RGB(0,255,0));
	cp_dImage.DrawLine(40,40,120,40);
	cp_dImage.SetForegroundColor(CP_RGB(255,255,0));
	cp_dImage.DrawRect(120,120,140,140);
	cp_dImage.SetForegroundColor(CP_RGB(0,0,255));
	cp_dImage.DrawCircle(80,100,40);
	cp_dImage.SetForegroundColor(CP_RGB(0,160,128));
	cp_dImage.DrawFillCircle(30,140,20);
	
	CPSTPosition pos[5];
	pos[0].x=20;pos[0].y=20;
	pos[1].x=50;pos[1].y=80;
	pos[2].x=90;pos[2].y=40;
	pos[3].x=120;pos[3].y=170;
	cp_dImage.SetForegroundColor(CP_RGB(0,255,0));
	cp_dImage.DrawBezier(pos,4);

	cp_dImage.SetForegroundColor(CP_RGB(0,0,255));
	cp_dImage.DrawLine(20,20,50,80);
	cp_dImage.DrawLine(50,80,90,40);
	cp_dImage.DrawLine(90,40,120,170);

	cp_dImage.SetForegroundColor(CP_RGB(92,30,5));
	pos[0].x=10;pos[0].y=10;
	pos[1].x=30;pos[1].y=60;
	pos[2].x=80;pos[2].y=120;
	pos[3].x=120;pos[3].y=80;
	cp_dImage.DrawFillPolygon(pos,4);

	cp_TabG3.Add(&cp_dImage);

	cp_dLab2.SetBackMode(CP_TRANSPARENT);
	cp_dLab2.SetBounds(20,230,180,20);
	cp_dLab2.SetText("ڕ`łCPImage");
	cp_TabG3.Add(&cp_dLab2);

	cp_dLab3.SetBackMode(CP_TRANSPARENT);
	cp_dLab3.SetForegroundColor(CP_RGB(0,192,0));
	cp_dLab3.SetBounds(20,254,180,20);
	cp_dLab3.SetText("CPLabel͕Fς܂");
	cp_TabG3.Add(&cp_dLab3);

	cp_dLab4.SetBackgroundColor(CP_RGB(255,192,0));
	cp_dLab4.SetForegroundColor(CP_RGB(0,0,64));
	cp_dLab4.SetBounds(20,278,180,20);
	cp_dLab4.SetAlign(CP_ALIGN_RIGHT);
	cp_dLab4.SetText("wiFςĉE");
	cp_TabG3.Add(&cp_dLab4);

}

#if __MWERKS__
	#pragma export on
#endif

extern_c void STDCALL create_interface(const IID &iid, int i, void **p, shade_interface *shade, void *) {
	unknown_interface *u = 0;
	
	u = new plugin_component;

	u->AddRef();
	*p = (void *)u;
};

extern_c int STDCALL has_interface(const IID &iid, shade_interface *shade) {
	if (iid == plugin_iid) return 1;
	return 0;
}

extern_c const char * STDCALL get_name(const IID &iid, int i, shade_interface *shade, void *) {
	return "CParts-Sample3";
}

extern_c int STDCALL get_interface_version(void *) {
	return interface_version;
}

extern_c int STDCALL get_id(const IID &iid, int i, void *) {
	return cparts_plugin_id;
}

extern_c bool STDCALL is_resident(const IID &iid, int i, void *) {
	//K풓
	return true;
}

extern_c int STDCALL get_text_encoding (shade_interface *shade, void *) {
	return shade->is_japanese_mode() ? plugin_interface::japanese_encoding : 0;
}

//----------------------------------------------//
//	C^[tF[X̎w					//
//----------------------------------------------//
extern_c void STDCALL get_info (shade_plugin_info &info, shade_interface *shade, void *) {

	info.sdk_version = SDK_VERSION;
	//info.recommended_shade_version = 35000;
	info.major_version = 1;
	info.minor_version = 0;
	info.micro_version = 0;
	info.build_number = 1;
	info.product_name = "CParts-Sample3";
	info.author = "Y.Yutaka";
	info.company = "";
	info.comments = "C-Parts̃eXgvOCłB\nGUIizu܂B";
}
