//--------------------------------------//
//	[CPartsTest7.cpp]					//
//	C-PartsgShadevOC		//
//	}EXJ[\̃eXg				//
//	2002.07.18 - 2002.09.28				//
//		Yutaka Yoshisaka				//
//--------------------------------------//
struct allocator_class { };

#include <vector>

#include <stdio.h>
#include <stdlib.h>

//C-PartsŎgpwb_
#include "CPartsMain.h"
#include "CPWindow.h"
#include "CPLabel.h"
#include "CPEditBox.h"
#include "CPPushButton.h"
#include "CPGroup.h"
#include "CPProgressBar.h"
#include "CPCheckBox.h"
#include "CPRadioButton.h"
#include "CPSlider.h"
#include "CPTab.h"
#include "CPComboBox.h"
#include "CPSpin.h"
#include "CPSpinEditBox.h"
#include "CPImage.h"

#include "CPartsSI.h"	//C-Parts - Shade ̃ubW

#if !INLINED_PLUGIN
#include "com.cpp"
#include "vectors.cpp"
#endif
#if WIN32
	#include "windows.h"
#endif
#include "shadetypes.h"
#include "sceneinterface.h"
#include "imageinterface.h"
#include "renderinginterface.h"
#include "renderingcontextinterface.h"
#include "correctioninterface.h"
#include "shapeclass.h"
#include "progressdialoginterface.h"
#include "sceneinterface.h"
#include "shadeinterface.h"
#include "pluginids.h"
#include "dllentries.h"
#include "camerainterface.h"
#include "shapeinterface.h"


//vOCID́A
//SDN胆[U[̌ŗLID炤悤ɂĂ
const int cparts_plugin_id = 0x434ff012;

struct plugin_component;
static plugin_component *lpThisClass=NULL;

struct plugin_component : plugin_interface {

	plugin_component () {
		lpThisClass=this;
	}

	~plugin_component () {
		//C-Parts̏I
		CPartsSI_Terminate();
	}

	virtual int get_shade_version () const { return SHADE_VERSION; }

	virtual void do_it (shade_interface *shade, scene_interface *scene, void *);
	virtual int get_id (void * = 0) { return cparts_plugin_id; }

	virtual void scene_opened (sxbool &b, scene_interface *scene, void * = 0) {
		//C-Parts
		CPartsSI_Initialize(scene);
	}

	//----------------------------------------------//
	//	EBhÉuvꂽ			//
	//----------------------------------------------//
	static void OnClose(CPPushButton *lpBut)
	{
		lpBut->GetParentWindow()->CloseWindow();	//EBhE
	}

	//----------------------------------------------//
	//	}EXCxg󂯎R[obN		//
	//----------------------------------------------//
	static void OnMouseEvent(CPWindow *lpWin,CPSTMouseEvent ev)
	{
		//cp_img}EXړĂꍇ
		if(ev.x>=20 && ev.x<20+100 && ev.y>=20 && ev.y<20+100){

			//NX̃J[\ɂ
			lpWin->SetCursor(CP_CURSOR_CROSS);

			return;
		}

		//cp_img2}EXړĂꍇ
		if(ev.x>=130 && ev.x<130+100 && ev.y>=20 && ev.y<20+100){

			//JX^̃J[\ɂ
			lpWin->SetCursor(lpThisClass->m_CursorNum);
			return;
		}

		//iftHgj̃J[\ɂ
		lpWin->SetCursor(CP_CURSOR_ARROW);
	}

private:

	//C-PartsŗpRg[
	CPWindow cp_win;
	CPPushButton cp_butClose;
	CPImage cp_img;
	CPImage cp_img2;
	int m_CursorNum;
};

void plugin_component::do_it(shade_interface *shade, scene_interface *scene, void *) {

	if (scene) {
		//--------------------------//
		//	_CAO̐	//
		//--------------------------//
		cp_win.Clear();
		if(cp_win.CreateNewDialog("eXg_CAO",120,120,240,180)<0){
			shade->message("CreateNewDialog failed!!");
			return;
		}

		//C[W̔zu
		cp_img.SetBounds(20,20,100,100);
		cp_img.ClearImage(CP_RGB(255,0,0));
		cp_img.SetHintText("\J[\\n\܂");
		cp_win.Add(&cp_img);

		//C[W̔zu
		cp_img2.SetBounds(130,20,100,100);
		cp_img2.ClearImage(CP_RGB(0,255,0));
		cp_img2.SetHintText("JX^J[\\n\܂");
		cp_win.Add(&cp_img2);

		//uv{^̔zu
		cp_butClose.SetText("");
		cp_butClose.SetBounds(20,140,120,24);
		cp_butClose.AttachSelectEvent(this->OnClose);
		cp_butClose.SetHintText("_CAO܂B");
		cp_win.Add(&cp_butClose);

		//------------------------------------------//
		//	JX^J[\̍쐬(16*16 dotŒ)	//
		//	J[\ŔȂ镔̌`w		//
		//	0 ... ̕							//
		//	1 ... wiEɂȂ镔				//
		//											//
		//	00000000 00000000						//
		//	00000001 10000000						//
		//	00011001 10110000						//
		//	00011001 10110000						//
		//	00001101 10110010						//
		//	00001101 10110110						//
		//	00000111 11110110						//
		//	01100111 11111110						//
		//	01110111 11111110						//
		//	00111111 11111100						//
		//	00011111 11111100						//
		//	00011111 11111100						//
		//	00001111 11111000						//
		//	00000111 11111000						//
		//	00000011 11110000						//
		//	00000011 11110000						//
		//											//
		//	L16iɂȂ̂ȉɂȂ	//
		//------------------------------------------//
		unsigned char cBuff[2*16]={
			0x00,0x00,		0x01,0x80,
			0x19,0xb0,		0x19,0xb0,
			0x0d,0xb2,		0x0d,0xb6,
			0x07,0xf6,		0x67,0xfe,
			0x77,0xfe,		0x3f,0xfc,
			0x1f,0xfc,		0x1f,0xfc,
			0x0f,0xf8,		0x07,0xf8,
			0x03,0xf0,		0x03,0xf0
		};

		//------------------------------------------//
		//	JX^J[\̍쐬(16*16 dotŒ)	//
		//	}XŇ`w					//
		//	0 ... ʂ						//
		//	1 ... }XNiwij̕				//
		//											//
		//	11111110 01111111						//
		//	11100100 00001111						//
		//	11000000 00000111						//
		//	11000000 00000101						//
		//	11100000 00000000						//
		//	11100000 00000000						//
		//	10000000 00000000						//
		//	00000000 00000000						//
		//	00000000 00000000						//
		//	10000000 00000001						//
		//	11000000 00000001						//
		//	11000000 00000001						//
		//	11100000 00000011						//
		//	11110000 00000011						//
		//	11111000 00000111						//
		//	11111000 00000111						//
		//											//
		//	L16iɂȂ̂ȉɂȂ	//
		//------------------------------------------//
		unsigned char cMaskBuff[2*16]={
			0xfe,0x7f,		0xe4,0x0f,
			0xc0,0x07,		0xc0,0x05,
			0xe0,0x00,		0xe0,0x00,
			0x80,0x00,		0x00,0x00,
			0x00,0x00,		0x80,0x01,
			0xc0,0x01,		0xc0,0x01,
			0xe0,0x03,		0xf0,0x03,
			0xf8,0x07,		0xf8,0x07
		};

		//JX^}EXJ[\̍쐬
		//cBuff      ... J[\`̃obt@(16*16hbg=2*16oCg)
		//cMaskBuff  ... }XN`̃obt@  (16*16hbg=2*16oCg)
		//(8,8)́AJ[\̒Sʒu
		//m_CursorNumɁA߂lƂăJ[\ԍ(100̘A)
		m_CursorNum=cp_win.CreateCursor(cBuff,cMaskBuff,8,8);

		//}EXCxg̓o^
		cp_win.AttachMouseEvent(&OnMouseEvent);

		//[__CAÕCxg
		cp_win.DoModal();
	}
}


#if __MWERKS__
	#pragma export on
#endif

extern_c void STDCALL create_interface (const IID &iid, int i, void **p, shade_interface *shade, void *) {
	unknown_interface *u = 0;
	
	u = new plugin_component;

	u->AddRef();
	*p = (void *)u;
};

extern_c int STDCALL has_interface (const IID &iid,shade_interface *shade) {
	if (iid == plugin_iid) return 1;
	return 0;
}

extern_c const char * STDCALL get_name (const IID &iid, int i, shade_interface *shade, void *) {
	return "CParts-Sample7";
}

extern_c int STDCALL get_interface_version (void *) {
	return interface_version;
}

extern_c int STDCALL get_id (const IID &iid, int i, void *) {
	return cparts_plugin_id;
}

extern_c bool STDCALL is_resident (const IID &iid, int i, void *) {
	//K풓
	return true;
}


extern_c int STDCALL get_text_encoding (shade_interface *shade, void *) {
	return shade->is_japanese_mode() ? plugin_interface::japanese_encoding : 0;
}

//----------------------------------------------//
//	C^[tF[X̎w					//
//----------------------------------------------//
extern_c void STDCALL get_info (shade_plugin_info &info, shade_interface *shade, void *) {

	info.sdk_version = SDK_VERSION;
	//info.recommended_shade_version = 35000;
	info.major_version = 1;
	info.minor_version = 0;
	info.micro_version = 0;
	info.build_number = 1;
	info.product_name = "CParts-Sample7";
	info.author = "Y.Yutaka";
	info.company = "";
	info.comments = "C-Parts̃eXgvOCłB\n}EXJ[\̐eXgłB";
}

