//----------------------------------------------//
//	[CPartsTest4.cpp]							//
//	C-PartsgShadevOC				//
//	C-Parts̃_CAOŎw肳ꂽl擾		//
//	2002.01.19 - 2002.09.28						//
//		Yutaka Yoshisaka						//
//----------------------------------------------//
struct allocator_class { };

#include <vector>

#include <stdio.h>
#include <stdlib.h>

//C-PartsŎgpwb_
#include "CPartsMain.h"
#include "CPWindow.h"
#include "CPLabel.h"
#include "CPEditBox.h"
#include "CPPushButton.h"
#include "CPGroup.h"
#include "CPProgressBar.h"
#include "CPCheckBox.h"
#include "CPRadioButton.h"
#include "CPSlider.h"
#include "CPTab.h"
#include "CPComboBox.h"
#include "CPSpin.h"
#include "CPSpinEditBox.h"
#include "CPImage.h"

#include "CPartsSI.h"	//C-Parts - Shade ̃ubW

#if !INLINED_PLUGIN
#include "com.cpp"
#include "vectors.cpp"
#endif
#if WIN32
	#include "windows.h"
#endif
#include "shadetypes.h"
#include "sceneinterface.h"
#include "imageinterface.h"
#include "renderinginterface.h"
#include "renderingcontextinterface.h"
#include "correctioninterface.h"
#include "shapeclass.h"
#include "progressdialoginterface.h"
#include "sceneinterface.h"
#include "shadeinterface.h"
#include "pluginids.h"
#include "dllentries.h"
#include "camerainterface.h"
#include "shapeinterface.h"

//vOCID́A
//SDN胆[U[̌ŗLID炤悤ɂĂ
const int cparts_plugin_id = 0x434ff004;

struct plugin_component : plugin_interface {
	plugin_component () {
	}

	~plugin_component () {
		//C-Parts̏I
		CPartsSI_Terminate();
	}

	virtual int get_shade_version () const { return SHADE_VERSION; }

	virtual void do_it (shade_interface *shade, scene_interface *scene, void *);
	virtual int get_id (void * = 0) { return cparts_plugin_id; }

	virtual void scene_opened (sxbool &b, scene_interface *scene, void * = 0) {
		//C-Parts
		CPartsSI_Initialize(scene);
	}

	//----------------------------------------------//
	//	EBhÉuvꂽ			//
	//----------------------------------------------//
	static void OnClose(CPPushButton *lpBut)
	{
		lpBut->GetParentWindow()->CloseWindow();	//EBhE
	}

private:

	//C-PartsŗpRg[
	CPWindow cp_win;
	CPPushButton cp_butClose;

public:

	CPCheckBox cp_chk01;
	CPCheckBox cp_chk02;
	CPEditBox cp_edit;
};

void plugin_component::do_it(shade_interface *shade, scene_interface *scene, void *) {

	char szBuff[256];
	char szStr[256];

	if (scene) {
		//--------------------------//
		//	_CAO̐	//
		//--------------------------//
		cp_win.Clear();
		if(cp_win.CreateNewDialog("eXg_CAO",120,120,160,130)<0){
			shade->message("CreateNewDialog failed!!");
			return;
		}

		//`FbN{bNX̔zu
		cp_chk01.SetText("Check01");
		cp_chk01.SetBounds(20,8,120,20);
		cp_win.Add(&cp_chk01);

		cp_chk02.SetText("Check02");
		cp_chk02.SetBounds(20,30,120,20);
		cp_win.Add(&cp_chk02);

		//GfBbg{bNX̔zu
		cp_edit.SetText("edit");
		cp_edit.SetBounds(20,60,120,20);
		cp_win.Add(&cp_edit);

		//uv{^̔zu
		cp_butClose.SetText("");
		cp_butClose.SetBounds(20,98,120,24);
		cp_butClose.AttachSelectEvent(this->OnClose);
		cp_win.Add(&cp_butClose);

		//[__CAÕCxg
		cp_win.DoModal();

		//͂ꂽl擾AbZ[WEBhEɕ\
		if(cp_chk01.IsSelected()){		//cp_chk01`FbNĂ
			shade->message("Check01 Selected.");
		}
		if(cp_chk02.IsSelected()){		//cp_chk02`FbNĂ
			shade->message("Check02 Selected.");
		}

		cp_edit.GetText(szStr,255);		//cp_edit͕̓擾
		sprintf(szBuff,"EditText=\"%s\"",szStr);
		shade->message(szBuff);
	}
}


#if __MWERKS__
	#pragma export on
#endif

extern_c void STDCALL create_interface (const IID &iid, int i, void **p, shade_interface *shade, void *) {
	unknown_interface *u = 0;
	
	u = new plugin_component;

	u->AddRef();
	*p = (void *)u;
};

extern_c int STDCALL has_interface (const IID &iid,shade_interface *shade) {
	if (iid == plugin_iid) return 1;
	return 0;
}

extern_c const char * STDCALL get_name (const IID &iid, int i, shade_interface *shade, void *) {
	return "CParts-Sample4";
}

extern_c int STDCALL get_interface_version (void *) {
	return interface_version;
}

extern_c int STDCALL get_id (const IID &iid, int i, void *) {
	return cparts_plugin_id;
}

extern_c bool STDCALL is_resident (const IID &iid, int i, void *) {
	//K풓
	return true;
}


extern_c int STDCALL get_text_encoding (shade_interface *shade, void *) {
	return shade->is_japanese_mode() ? plugin_interface::japanese_encoding : 0;
}

//----------------------------------------------//
//	C^[tF[X̎w					//
//----------------------------------------------//
extern_c void STDCALL get_info (shade_plugin_info &info, shade_interface *shade, void *) {

	info.sdk_version = SDK_VERSION;
	//info.recommended_shade_version = 35000;
	info.major_version = 1;
	info.minor_version = 0;
	info.micro_version = 0;
	info.build_number = 1;
	info.product_name = "CParts-Sample4";
	info.author = "Y.Yutaka";
	info.company = "";
	info.comments = "C-Parts̃eXgvOCłB\n[__CAO\́AGUIȉԂ擾܂B";
}

