//////////////////////////////////////
//	[CPButton.h]					//
//	{^`EǗNX		//
//	C-Parts Ver1.07ǉ			//
//	from 2002.01.25					//
//	to   2002.07.19					//
//	Writer : Yoshisaka Yutaka		//
//////////////////////////////////////

#ifndef _CPBUTTON_H
#define _CPBUTTON_H

#include "CPartsMain.h"
#include "CPGraphics.h"
#include "CPIcon.h"

#define CP_BUTTON_NORMAL	0	//ʂ̃{^
#define CP_BUTTON_CHOICE	1	//{^IĂ
#define CP_BUTTON_PUSH		2	//{^Ă

class CPButton;
typedef void (* LP_BUTTONPROC)(CPButton *);

class LibExport CPButton : public CPGraphics
{
private:
	//̕sȂ߂̋lߕ
	CP_SHLIB_DUMMY512

public:
	CP_SHLIB_DUMMY128

	//----------------------------------------------//
	//	ʂɌJ郁\bh̐錾				//
	//----------------------------------------------//
	CPButton();
	~CPButton();

	//----- ݒs -----
	void SetBounds(int x,int y,int wid,int hei);	//\ʒuƃTCYw
	void SetSize(int wid,int hei);					//\TCYw
	void SetLocate(int x,int y);					//\ʒuw
	void SetVisible(CP_BOOL f);						//\邩Ȃ

	void SetEnable(CP_BOOL f);						//Lɂ邩ǂiDF\j
	void SetText(char *lpStr);						//\镶w
	void SetBackgroundColor(unsigned long col);		//wiFw
	void SetForegroundColor(unsigned long col);		//OiFw
	void SetAlign(int align);						//̐\ʒuw
	void SetSelected(CP_BOOL f);					//{^I

	void Clear();									//ׂĉ

	//----- 擾s -----
	void GetText(char *lpStr,int StrLen);			//\镶擾
	void GetBounds(CPSTRect *lpRec);				//\ʒuETCY擾
	void GetSize(CPSTSize *lpSize);					//\TCY擾
	void GetLocate(CPSTPosition *lpPos);			//\ʒu擾
	CP_BOOL IsVisible();							//\邩Ȃ
	CP_BOOL IsEnable();								//LEɂ邩ǂ
	CP_BOOL IsSelected();							//IĂ邩ǂ

	unsigned long GetBackgroundColor();				//wiF擾
	unsigned long GetForegroundColor();				//OiF擾
	int GetAlign();									//̐\ʒu擾

	CPWindow *GetParentWindow();	//ẽEBhENX擾
	void Repaint();					//Rg[̍ĕ`s
	
	//----- Cxg̑Ή -----
	CP_BOOL AttachSelectEvent(LP_BUTTONPROC lpProc);	//{^ꂽꍇ̃Cxg󂯎
	void DetachSelectEvent();							//Cxg̉

	//----- c[qg̐p -----
	void SetHintText(char *lpStr);					//c[qg̕wis\j
	void SetHintFontSize(int fSize);				//c[qg̃tHgTCYw
	void SetHintForegroundColor(unsigned long col);	//c[qg̕Fw
	void SetHintBackgroundColor(unsigned long col);	//c[qg̔wiFw

	//----- ACR̊֘AÂ(C-Parts Ver1.08)
	void SetIcon(CPIcon *lpIcon);

};

#endif
