//////////////////////////////////////
//	[CPCheckBox.h]					//
//	`FbN{bNX`EǗNX//
//	from 2001.02.10					//
//	to   2002.07.19					//
//	Writer : Yoshisaka Yutaka		//
//////////////////////////////////////

#ifndef _CPCHECKBOX_H
#define _CPCHECKBOX_H

#include "CPartsMain.h"
#include "CPGraphics.h"

class CPWindow;
class CPCheckBox;
typedef void (* LP_CHECKBOXPROC)(CPCheckBox *);

class LibExport CPCheckBox : public CPGraphics
{

private:
	//̕sȂ߂̋lߕ
	CP_SHLIB_DUMMY256

public:
	CP_SHLIB_DUMMY128

	//----------------------------------------------//
	//	ʂɌJ郁\bh̐錾				//
	//----------------------------------------------//
	CPCheckBox();
	~CPCheckBox();

	//----- ݒs -----
	void SetBounds(int x,int y,int wid,int hei);	//\ʒuƃTCYw
	void SetSize(int wid,int hei);					//\TCYw
	void SetLocate(int x,int y);					//\ʒuw
	void SetVisible(CP_BOOL f);						//\邩Ȃ

	void SetEnable(CP_BOOL f);						//Lɂ邩ǂiDF\j
	void SetText(char *lpStr);						//\镶w
	void SetSelected(CP_BOOL f);					//`FbN{bNXI
	void SetForegroundColor(unsigned long col);		//OiFw

	void Clear();									//ׂĉ

	//----- 擾s -----
	void GetText(char *lpStr,int StrLen);			//\镶擾
	void GetBounds(CPSTRect *lpRec);				//\ʒuETCY擾
	void GetSize(CPSTSize *lpSize);					//\TCY擾
	void GetLocate(CPSTPosition *lpPos);			//\ʒu擾
	CP_BOOL IsVisible();							//\邩Ȃ

	CP_BOOL IsEnable();								//LEɂ邩ǂ
	unsigned long GetForegroundColor();				//OiF擾
	CP_BOOL IsSelected();							//`FbNĂ邩ǂ

	//----- Cxg̑Ή -----
	CP_BOOL AttachSelectEvent(LP_CHECKBOXPROC lpProc);	//Iꂽꍇ̃Cxg󂯎
	void DetachSelectEvent();							//Cxg̉

	CPWindow *GetParentWindow();	//ẽEBhENX擾
	void Repaint();					//Rg[̍ĕ`s
	
	//----- c[qg̐p -----
	void SetHintText(char *lpStr);					//c[qg̕wis\j
	void SetHintFontSize(int fSize);				//c[qg̃tHgTCYw
	void SetHintForegroundColor(unsigned long col);	//c[qg̕Fw
	void SetHintBackgroundColor(unsigned long col);	//c[qg̔wiFw

};
#endif
