//////////////////////////////////////
//	[CPGraphics.h]					//
//	OtBNX`NX			//
//	from 2000.11.22					//
//	to   2002.07.19					//
//	Writer : Yoshisaka Yutaka		//
//////////////////////////////////////

#ifndef _CPGRAPHICS_H
#define _CPGRAPHICS_H

#include "CPartsMain.h"

#define CP_LINE_BORDER		1	//ʂ̐
#define CP_LINE_DASH		2	//j

class LibExport CPGraphics
{
private:
	//̕sȂ߂̋lߕ
	CP_SHLIB_DUMMY256

public:
	CP_SHLIB_DUMMY128

	CPGraphics();
	~CPGraphics();

	//OiFݒ
	void SetForegroundColor(unsigned long col);

	//wiFݒ
	void SetBackgroundColor(unsigned long col);

	//i܂͓_j̑ݒ
	void SetSize(int size);

	//_`
	void SetPixel(int x,int y);
	
	//`
	void DrawLine(int x1,int y1,int x2,int y2,int mode=CP_LINE_BORDER);

	//``
	void DrawRect(int x1,int y1,int x2,int y2,int mode=CP_LINE_BORDER);

	//`hԂ`
	void DrawFillRect(int x1,int y1,int x2,int y2);

	//~`
	void DrawCircle(int x1,int y1,int x2,int y2);

	//~hԂ̕`
	void DrawFillCircle(int x1,int y1,int x2,int y2);

	//~ʂ̕`
	void DrawArc(int x1,int y1,int x2,int y2,int sPos1,int sPos2);

	//̃tHgTCYݒ
	void SetFontSize(int fsize);

	//tHgTCY擾
	int GetFontSize();

	//̕`
	void DrawText(int x,int y,char *lpStr);

	//̕`i`j
	void DrawBoxText(int x1,int y1,int x2,int y2,char *lpStr,int align);

	//̕isNZPʁj擾
	int GetTextWidth(char *lpStr);

	//|S̕`
	void DrawPolygon(CPSTPosition *lpPos,int num);

	//hԂ|S̕`
	void DrawFillPolygon(CPSTPosition *lpPos,int num);

	//l~̎lp``
	void DrawRoundRect(int x1,int y1,int x2,int y2,int r,int mode=CP_LINE_BORDER);

	//l~̎lp`hԂ`
	void DrawFillRoundRect(int x1,int y1,int x2,int y2,int r);

	//xWFȐ̕`
	void DrawBezier(CPSTPosition *lpPos,int num);
};

#endif
