//////////////////////////////////////
//	[CPSlider.h]					//
//	XC_[`EǗNX		//
//	from 2001.02.11					//
//	to   2002.07.19					//
//	Writer : Yoshisaka Yutaka		//
//////////////////////////////////////

#ifndef _CPSLIDER_H
#define _CPSLIDER_H

#include "CPartsMain.h"
#include "CPGraphics.h"

class CPSlider;
typedef void (* LP_SLIDERPROC)(CPSlider *);

//XC_[̃TCY
#define CP_SLIDER_NORMAL	0
#define CP_SLIDER_SMALL		1

class LibExport CPSlider : public CPGraphics
{
private:
	//̕sȂ߂̋lߕ
	CP_SHLIB_DUMMY256

public:
	CP_SHLIB_DUMMY128

	//----------------------------------------------//
	//	ʂɌJ郁\bh̐錾				//
	//----------------------------------------------//
	CPSlider();
	CPSlider(CP_BOOL ruler,int size=CP_SLIDER_NORMAL);
	~CPSlider();

	//----- ݒs -----
	void SetBounds(int x,int y,int wid,int hei);	//\ʒuƃTCYw
	void SetSize(int wid,int hei);					//\TCYw
	void SetLocate(int x,int y);					//\ʒuw
	void SetVisible(CP_BOOL f);						//\邩Ȃ

	void SetEnable(CP_BOOL f);						//Lɂ邩ǂiDF\j
	CP_BOOL SetRange(int min,int max);				//XC_[̍ŏEőlݒ
	void SetPosition(int p);						//XC_[݂̌̈ʒuݒ
	void SetRuler(CP_BOOL m);						//[`悷邩
	void SetSliderSize(int s);						//XC_[̃TCỸ[hݒ(CP_SLIDER_NORMAL/CP_SLIDER_SMALL)

	void Clear();									//ׂĉ

	//----- 擾s -----
	void GetBounds(CPSTRect *lpRec);				//\ʒuETCY擾
	void GetSize(CPSTSize *lpSize);					//\TCY擾
	void GetLocate(CPSTPosition *lpPos);			//\ʒu擾
	CP_BOOL IsVisible();							//\邩Ȃ

	CP_BOOL IsEnable();								//LEɂ邩ǂ
	CP_BOOL GetRange(int *lpMin,int *lpMax);		//XC_[͈̔͂擾
	int GetPosition();								//XC_[̈ʒu擾
	
	CP_BOOL IsRuler();
	int GetSliderSize();

	//----- Cxg̑Ή -----
	CP_BOOL AttachFocusEvent(LP_SLIDERPROC lpProc);	//Iꂽꍇ̃Cxg󂯎
	void DetachFocusEvent();						//Cxg̉
	CP_BOOL AttachChangeEvent(LP_SLIDERPROC lpProc);//lύXꂽꍇ̃Cxg󂯎
	void DetachChangeEvent();						//Cxg̉

	CPWindow *GetParentWindow();	//ẽEBhENX擾
	void Repaint();					//Rg[̍ĕ`s

	//----- c[qg̐p -----
	void SetHintText(char *lpStr);					//c[qg̕wis\j
	void SetHintFontSize(int fSize);				//c[qg̃tHgTCYw
	void SetHintForegroundColor(unsigned long col);	//c[qg̕Fw
	void SetHintBackgroundColor(unsigned long col);	//c[qg̔wiFw

};
#endif
