//////////////////////////////////////
//	[CPSpin.h]						//
//	Xs{^`EǗNX	//
//	from 2001.10.23					//
//	to   2002.07.19					//
//	Writer : Yoshisaka Yutaka		//
//////////////////////////////////////

#ifndef _CPSPIN_H
#define _CPSPIN_H

#include "CPartsMain.h"
#include "CPGraphics.h"

class CPSpinEditBox;
class CPSpin;
typedef void (* LP_SPINPROC)(CPSpin *);
typedef void (* LP_SPINEDITBOXPROC)(CPSpinEditBox *);

class LibExport CPSpin : public CPGraphics
{
private:
	//̕sȂ߂̋lߕ
	CP_SHLIB_DUMMY256

public:
	CP_SHLIB_DUMMY128

	//----------------------------------------------//
	//	ʂɌJ郁\bh̐錾				//
	//----------------------------------------------//
	CPSpin();
	~CPSpin();

	//----- ݒs -----
	void SetBounds(int x,int y,int wid,int hei);	//\ʒuƃTCYw
	void SetSize(int wid,int hei);					//\TCYw
	void SetLocate(int x,int y);					//\ʒuw
	void SetVisible(CP_BOOL f);						//\邩Ȃ

	void SetEnable(CP_BOOL f);							//Lɂ邩ǂiDF\j
	void SetBackgroundColor(unsigned long col);		//wiFw
	void SetForegroundColor(unsigned long col);		//OiFw

	void Clear();									//ׂĉ

	//----- 擾s -----
	void GetBounds(CPSTRect *lpRec);				//\ʒuETCY擾
	void GetSize(CPSTSize *lpSize);					//\TCY擾
	void GetLocate(CPSTPosition *lpPos);			//\ʒu擾
	CP_BOOL IsVisible();							//\邩Ȃ

	CP_BOOL IsEnable();								//LEɂ邩ǂ
	unsigned long GetBackgroundColor();				//wiF擾
	unsigned long GetForegroundColor();				//OiF擾

	//----- Cxg̑Ή -----
	CP_BOOL AttachUpSelectEvent(LP_SPINPROC lpProc);			//Up{^ꂽꍇ̃Cxg󂯎
	void DetachUpSelectEvent();								//Cxg̉
	CP_BOOL AttachDownSelectEvent(LP_SPINPROC lpProc);			//Down{^ꂽꍇ̃Cxg󂯎
	void DetachDownSelectEvent();							//Cxg̉

	//XsGfBbg{bNXpCxg󂯂Ƃ
	CP_BOOL AttachUpSelectEvent(CPSpinEditBox *lpC,LP_SPINEDITBOXPROC lpProc);	//Up{^ꂽꍇ̃Cxg󂯎
	CP_BOOL AttachDownSelectEvent(CPSpinEditBox *lpC,LP_SPINEDITBOXPROC lpProc);	//Down{^ꂽꍇ̃Cxg󂯎

	CPWindow *GetParentWindow();	//ẽEBhENX擾
	void Repaint();					//Rg[̍ĕ`s

	//----- c[qg̐p -----
	void SetHintText(char *lpStr);					//c[qg̕wis\j
	void SetHintFontSize(int fSize);				//c[qg̃tHgTCYw
	void SetHintForegroundColor(unsigned long col);	//c[qg̕Fw
	void SetHintBackgroundColor(unsigned long col);	//c[qg̔wiFw

};

#endif
 