//--------------------------------------//
//	[CPartsTest2.cpp]					//
//	C-PartsgShadevOC		//
//	100msƂ̃^C}[̃eXg			//
//		CAj[V			//
//	2002.01.01 - 2002.09.28				//
//		Yutaka Yoshisaka				//
//--------------------------------------//
struct allocator_class { };

#include <vector>

#include <stdio.h>
#include <stdlib.h>

//C-PartsŎgpwb_
#include "CPartsMain.h"
#include "CPWindow.h"
#include "CPLabel.h"
#include "CPEditBox.h"
#include "CPPushButton.h"
#include "CPGroup.h"
#include "CPProgressBar.h"
#include "CPCheckBox.h"
#include "CPRadioButton.h"
#include "CPSlider.h"
#include "CPTab.h"
#include "CPComboBox.h"
#include "CPSpin.h"
#include "CPSpinEditBox.h"
#include "CPImage.h"

#include "CPartsSI.h"	//C-Parts - Shade ̃ubW

#if !INLINED_PLUGIN
#include "com.cpp"
#include "vectors.cpp"
#endif
#if WIN32
	#include "windows.h"
#endif
#include "shadetypes.h"
#include "sceneinterface.h"
#include "imageinterface.h"
#include "renderinginterface.h"
#include "renderingcontextinterface.h"
#include "correctioninterface.h"
#include "shapeclass.h"
#include "progressdialoginterface.h"
#include "sceneinterface.h"
#include "shadeinterface.h"
#include "pluginids.h"
#include "dllentries.h"
#include "camerainterface.h"
#include "shapeinterface.h"


struct plugin_component;
plugin_component *lpThis=NULL;

//vOCID́A
//SDN胆[U[̌ŗLID炤悤ɂĂ
const int cparts_plugin_id = 0x434ff002;

struct plugin_component : plugin_interface {
	plugin_component () {
		lpThis=this;
	}

	~plugin_component () {
		//C-Parts̏I
		CPartsSI_Terminate();
	}

	virtual int get_shade_version () const { return SHADE_VERSION; }

	virtual void do_it (shade_interface *shade, scene_interface *scene, void *);
	virtual int get_id (void * = 0) { return cparts_plugin_id; }

	virtual void scene_opened (sxbool &b, scene_interface *scene, void * = 0) {
		//C-Parts
		CPartsSI_Initialize(scene);
	}

	//----------------------------------------------//
	//	EBhÉuvꂽ			//
	//----------------------------------------------//
	static void OnClose(CPPushButton *lpBut)
	{
		lpBut->GetParentWindow()->CloseWindow();	//EBhE
	}

	//摜̔wiNA
	static void OnClear(CPPushButton *lpBut)
	{
		lpThis->cp_image.ClearImage(CP_RGB(0,0,32));
	}

	//100msƂC-PartsĂ΂
	static void OnTimer(CPWindow *lpWin);

public:
	//R[obN֐łgpIuWFNg
	CPWindow cp_win;		//C-PartspEBhEǗNX
	CPImage cp_image;		//C-Parts摜ǗNX

private:

	//C-PartsŗpRg[
	CPLabel cp_lab1;
	CPPushButton cp_butClose;
	CPPushButton cp_butClear;
};

//--------------------------------------//
//	100msƂC-PartsĂ΂		//
//	^C}[Cxg̃R[obN֐	//
//--------------------------------------//
void plugin_component::OnTimer(CPWindow *lpWin)
{
	CPImage *lpImage;
	static int xPos1=0;
	static int yPos1=0;
	static int xPos2=0;
	static int yPos2=0;

	static int xDest1=(rand()&15)-8;
	static int yDest1=(rand()&15)-8;
	static int xDest2=(rand()&15)-8;
	static int yDest2=(rand()&15)-8;
	static int rr=0;
	static int gg=0;
	static int bb=0;
	static int destR=1;
	static int destG=1;
	static int destB=1;

	xPos1+=xDest1;
	yPos1+=yDest1;
	xPos2+=xDest2;
	yPos2+=yDest2;

	if(xPos1<=0){
		xPos1=0;
		xDest1=(rand()&15);
	}
	if(xPos1>=320){
		xPos1=320;
		xDest1=-(rand()&15);
	}
	if(yPos1<=0){
		yPos1=0;
		yDest1=(rand()&15);
	}
	if(yPos1>=240){
		yPos1=240;
		yDest1=-(rand()&15);
	}

	if(xPos2<=0){
		xPos2=0;
		xDest2=(rand()&15);
	}
	if(xPos2>=320){
		xPos2=320;
		xDest2=-(rand()&15);
	}
	if(yPos2<=0){
		yPos2=0;
		yDest2=(rand()&15);
	}
	if(yPos2>=240){
		yPos2=240;
		yDest2=-(rand()&15);
	}

	if(destR){
		rr+=rand()&7;
		if(rr>255){
			rr=255;
			destR=0;
		}
	} else {
		rr-=rand()&7;
		if(rr<0){
			rr=0;
			destR=1;
		}
	}
	if(destG){
		gg+=rand()&7;
		if(gg>255){
			gg=255;
			destG=0;
		}
	} else {
		gg-=rand()&7;
		if(gg<0){
			gg=0;
			destG=1;
		}
	}
	if(destB){
		bb+=rand()&7;
		if(bb>255){
			bb=255;
			destB=0;
		}
	} else {
		bb-=rand()&7;
		if(bb<0){
			bb=0;
			destB=1;
		}
	}

	lpImage=&(lpThis->cp_image);

	lpImage->SetForegroundColor(CP_RGB(rr,gg,bb));	//`F̎w
	lpImage->DrawLine(xPos1,yPos1,xPos2,yPos2);		//̕`
	lpImage->Repaint();								//摜̍ĕ`
}


void plugin_component::do_it(shade_interface *shade, scene_interface *scene, void *) {

	if (scene) {
		//--------------------------//
		//	_CAO̐	//
		//--------------------------//
		if(cp_win.CreateNewDialog("Aj[ṼeXg",120,120,400,340)<0){
			shade->message("CreateNewDialog failed!!");
			return;
		}

		//--------------------------//
		//	_CAO̕iݒ	//
		//--------------------------//
		cp_lab1.SetText("Aj[ṼeXgłB");
		cp_lab1.SetBounds(16,8,200,20);
		cp_lab1.SetAlign(CP_ALIGN_LEFT);
		cp_lab1.SetBackMode(CP_TRANSPARENT);
		cp_win.Add(&cp_lab1);

		cp_image.SetBounds(40,48,320,240);
		cp_image.ClearImage(CP_RGB(0,0,32));
		cp_win.Add(&cp_image);

		cp_butClear.SetText("NA");
		cp_butClear.SetBounds(16,300,120,24);
		cp_butClear.AttachSelectEvent(this->OnClear);
		cp_win.Add(&cp_butClear);

		//uv{^̔zu
		cp_butClose.SetText("");
		cp_butClose.SetBounds(260,8,120,24);
		cp_butClose.AttachSelectEvent(this->OnClose);
		cp_win.Add(&cp_butClose);

		//^C}[Cxg̎󂯎֐ݒ
		cp_win.AttachTimerEvent(this->OnTimer);

		//[__CAÕCxg
		cp_win.DoModal();
	}
}

#if __MWERKS__
	#pragma export on
#endif

extern_c void STDCALL create_interface (const IID &iid, int i, void **p, shade_interface *shade, void *) {
	unknown_interface *u = 0;
	
	u = new plugin_component;

	u->AddRef();
	*p = (void *)u;
};

extern_c int STDCALL has_interface (const IID &iid,shade_interface *shade) {
	if (iid == plugin_iid) return 1;
	return 0;
}

extern_c const char * STDCALL get_name (const IID &iid, int i, shade_interface *shade, void *) {
	return "CParts-Sample2";
}

extern_c int STDCALL get_interface_version (void *) {
	return interface_version;
}

extern_c int STDCALL get_id (const IID &iid, int i, void *) {
	return cparts_plugin_id;
}

extern_c bool STDCALL is_resident (const IID &iid, int i, void *) {
	//K풓
	return true;
}


extern_c int STDCALL get_text_encoding (shade_interface *shade, void *) {
	return shade->is_japanese_mode() ? plugin_interface::japanese_encoding : 0;
}

//----------------------------------------------//
//	C^[tF[X̎w					//
//----------------------------------------------//
extern_c void STDCALL get_info (shade_plugin_info &info, shade_interface *shade, void *) {

	info.sdk_version = SDK_VERSION;
	//info.recommended_shade_version = 35000;
	info.major_version = 1;
	info.minor_version = 0;
	info.micro_version = 0;
	info.build_number = 1;
	info.product_name = "CParts-Sample2";
	info.author = "Y.Yutaka";
	info.company = "";
	info.comments = "C-Parts̃eXgvOCłB\n^C}[荞݂̃eXgłB";
}
